@ -1,38 +1,30 @@
#!/usr/bin/env bash
#!/usr/bin/env bash -ex
set -euo pipefail
set -o errexit
shopt -s inherit_errexit nullglob
set -o errtrace
YW = ` echo "\033[33m" `
set -o nounset
set -o pipefail
shopt -s expand_aliases
alias die = 'EXIT=$? LINE=$LINENO error_exit'
trap die ERR
trap 'die "Script interrupted."' INT
function error_exit( ) {
trap - ERR
local DEFAULT = 'Unknown failure occured.'
local REASON = " \e[97m ${ 1 :- $DEFAULT } \e[39m "
local FLAG = " \e[91m[ERROR:LXC] \e[93m $EXIT @ $LINE "
msg " $FLAG $REASON "
exit $EXIT
}
function msg( ) {
local TEXT = " $1 "
echo -e " $TEXT "
}
RD = ` echo "\033[01;31m" `
RD = ` echo "\033[01;31m" `
BL = ` echo "\033[36m" `
BL = ` echo "\033[36m" `
GN = ` echo "\033[1;92m" `
GN = ` echo "\033[1;92m" `
CL = ` echo "\033[m" `
CL = ` echo "\033[m" `
CM = " ${ GN } ✓ ${ CL } "
CROSS = " ${ RD } ✗ ${ CL } "
RETRY_NUM = 10
RETRY_NUM = 10
RETRY_EVERY = 3
RETRY_EVERY = 3
NUM = $RETRY_NUM
NUM = $RETRY_NUM
CM = " ${ GN } ✓ ${ CL } "
CROSS = " ${ RD } ✗ ${ CL } "
BFR = "\\r\\033[K"
HOLD = "-"
function msg_info( ) {
local msg = " $1 "
echo -ne " ${ HOLD } ${ YW } ${ msg } ... "
}
function msg_ok( ) {
local msg = " $1 "
echo -e " ${ BFR } ${ CM } ${ GN } ${ msg } ${ CL } "
}
echo -en " ${ GN } Setting up Container OS... "
msg_info "Setting up Container OS "
sed -i " / $LANG / s/\(^# \)// " /etc/locale.gen
sed -i " / $LANG / s/\(^# \)// " /etc/locale.gen
locale-gen >/dev/null
locale-gen >/dev/null
while [ " $( hostname -I) " = "" ] ; do
while [ " $( hostname -I) " = "" ] ; do
@ -45,37 +37,36 @@ while [ "$(hostname -I)" = "" ]; do
exit 1
exit 1
fi
fi
done
done
echo -e " ${ CM } ${ CL } \r "
msg_ok "Set up Container OS"
echo -en " ${ GN } Network Connected: ${ BL } $( hostname -I) ${ CL } "
msg_ok " Network Connected: ${ BL } $( hostname -I) "
echo -e " ${ CM } ${ CL } \r "
echo -en " ${ GN } Updating Container OS... "
msg_info "Updating Container OS "
apt update & >/dev/null
apt update & >/dev/null
apt-get -qqy upgrade & >/dev/null
apt-get -qqy upgrade & >/dev/null
echo -e " ${ CM } ${ CL } \r "
msg_ok "Updated Container OS "
echo -en " ${ GN } Installing Dependencies... "
msg_info "Installing Dependencies "
apt-get install -y curl & >/dev/null
apt-get install -y curl & >/dev/null
apt-get install -y sudo & >/dev/null
apt-get install -y sudo & >/dev/null
apt-get install -y git & >/dev/null
apt-get install -y git & >/dev/null
echo -e " ${ CM } ${ CL } \r "
msg_ok "Installed Dependencies "
echo -en " ${ GN } Setting up Node.js Repository... "
msg_info "Setting up Node.js Repository "
sudo curl -sL https://deb.nodesource.com/setup_16.x | sudo -E bash - & >/dev/null
sudo curl -sL https://deb.nodesource.com/setup_16.x | sudo -E bash - & >/dev/null
echo -e " ${ CM } ${ CL } \r "
msg_ok "Set up Node.js Repository "
echo -en " ${ GN } Installing Node.js... "
msg_info "Installing Node.js "
sudo apt-get install -y nodejs & >/dev/null
sudo apt-get install -y nodejs & >/dev/null
echo -e " ${ CM } ${ CL } \r "
msg_ok "Installed Node.js "
echo -en " ${ GN } Installing Uptime Kuma... "
msg_info "Installing Uptime Kuma "
git clone https://github.com/louislam/uptime-kuma.git & >/dev/null
git clone https://github.com/louislam/uptime-kuma.git & >/dev/null
mv uptime-kuma /opt/uptime-kuma
mv uptime-kuma /opt/uptime-kuma
cd /opt/uptime-kuma
cd /opt/uptime-kuma
npm run setup & >/dev/null
npm run setup & >/dev/null
echo -e " ${ CM } ${ CL } \r "
msg_ok "Installed Uptime Kuma "
echo -en " ${ GN } Creating Service file uptime-kuma.service... "
msg_info "Creating Service "
service_path = "/etc/systemd/system/uptime-kuma.service"
service_path = "/etc/systemd/system/uptime-kuma.service"
echo " [Unit]
echo " [Unit]
Description = uptime-kuma
Description = uptime-kuma
@ -90,11 +81,11 @@ ExecStart=/usr/bin/npm start
[ Install]
[ Install]
WantedBy = multi-user.target" > $service_path
WantedBy = multi-user.target" > $service_path
systemctl enable --now uptime-kuma.service & >/dev/null
systemctl enable --now uptime-kuma.service & >/dev/null
echo -e " ${ CM } ${ CL } \r "
msg_ok "Created Service "
PASS = $( grep -w "root" /etc/shadow | cut -b6) ;
PASS = $( grep -w "root" /etc/shadow | cut -b6) ;
if [ [ $PASS != $ ] ] ; then
if [ [ $PASS != $ ] ] ; then
echo -en " ${ GN } Customizing Container... "
msg_info "Customizing Container "
rm /etc/motd
rm /etc/motd
rm /etc/update-motd.d/10-uname
rm /etc/update-motd.d/10-uname
touch ~/.hushlogin
touch ~/.hushlogin
@ -107,11 +98,11 @@ ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,3840
EOF
EOF
systemctl daemon-reload
systemctl daemon-reload
systemctl restart $( basename $( dirname $GETTY_OVERRIDE ) | sed 's/\.d//' )
systemctl restart $( basename $( dirname $GETTY_OVERRIDE ) | sed 's/\.d//' )
echo -e " ${ CM } ${ CL } \r "
msg_ok "Customized Container "
fi
fi
echo -en " ${ GN } Cleanup... "
msg_info "Cleaning up "
apt-get autoremove >/dev/null
apt-get autoremove >/dev/null
apt-get autoclean >/dev/null
apt-get autoclean >/dev/null
rm -rf /var/{ cache,log} /* /var/lib/apt/lists/*
rm -rf /var/{ cache,log} /* /var/lib/apt/lists/*
echo -e " ${ CM } ${ CL } \n "
msg_ok "Cleaned "